/*
 *  logic.cpp
 *  Launchonme_terminal
 *
 *  Created by Johan Larsby on 12/4/09.
 *  Copyright 2009 __MyCompanyName__. All rights reserved.
 *
 */
#include <iostream>
#include "logic.h"
#include "LaunchpadHelper.h"

bool is_running = true;


int xVel = -1;
int yVel = -1;
int X=3;
int Y=5;
int n;
char c;


static unsigned char  notemap[8][8] = 
{ 
	{0,1,2,3,4,5,6,7}, 
	{16,1+16,2+16,3+16,4+16,5+16,6+16,7+16}, 
	{32,1+32,2+32,3+32,4+32,5+32,6+32,7+32}, 
	{48,1+48,2+48,3+48,4+48,5+48,6+48,7+48}, 
	{64,1+64,2+64,3+64,4+64,5+64,6+64,7+64}, 
	{80,1+80,2+80,3+80,4+80,5+80,6+80,7+80}, 
	{96,1+96,2+96,3+96,4+96,5+96,6+96,7+96}, 
	{112,1+112,2+112,3+112,4+112,5+112,6+112,7+112}, 
};

static unsigned char  noteONmap[8][8] = 
{ 
	{0,0,0,0,0,0,0,0}, 
	{0,0,0,0,0,0,0,0}, 
	{0,0,0,0,0,0,0,0}, 
	{0,0,0,0,0,0,0,0}, 
	{0,0,0,0,0,0,0,0}, 
	{0,0,0,0,0,0,0,0}, 
	{0,0,0,0,0,0,0,0}, 
	{0,0,0,0,0,0,0,0}, 
	
	
};


void setup()
{
	printf("called resetlaunchpad");
	resetLaunchPad();
}

void loop1()
{
	while(is_running)
	{
		
		X += xVel;
		Y += yVel;
		
		if (X<0) 
		{
			X=1;
			xVel=1;
		}
		if (Y<0) 
		{
			Y=1;
			yVel=1;
		}
		
		if (X>7) 
		{
			X=7;
			xVel=-1;
		}
		
		if (Y>7) 
		{
			Y=7;
			yVel=-1;
		}
		
		if(noteONmap[X][Y]==1)
		{
			xVel*=-1;
			sendShortToHost( 144 , notemap[X][Y], 127 );  
			sendShortToLaunchpad(144,notemap[X][Y],red_full);		
		}
		
		sendShortToLaunchpad(144,notemap[X][Y],yellow_full);
		usleep(90000);
 		sendShortToLaunchpad(144,notemap[X][Y],light_off);
		
		if(noteONmap[X][Y]==1)
		{
			
			sendShortToHost( 144 , notemap[X][Y], 0 );  
			sendShortToLaunchpad(144,notemap[X][Y],red_full);
			
		}
	}		
	
}


void loop2()
{
	while(is_running)
	{ 
		n = read(0, &c, 1);
		if (c =='q') 
		{
			is_running = false;
			stopHelper();
		}
	}	
	
}


void handleMIDIMessageFromHost( int status, int data1,int  data2)
{
	
		printf("handleMIDIMessageFromHost: ");
		
		printf("status %d | ",status);
		printf("data1 %d | ",data1);
		printf("data2 %d \n ",data2);
}


void handleMIDIMessageFromLaunchpad( int status, int data1,int  data2)
{
	int xeee,yeee=0;
	printf("handleMIDIMessageFromLaunchpad: ");
	
	printf("status %d | ",status);
	printf("data1 %d | ",data1);
	printf("data2 %d \n ",data2);
	
	for( xeee=0;xeee<8;xeee++)
		for( yeee=0;yeee<8;yeee++)
		{
			if(notemap[xeee][yeee]==data1)
			{
				if(data2==127)
					if(noteONmap[xeee][yeee]==1)
					{
						noteONmap[xeee][yeee]=0;
						sendShortToLaunchpad(144,notemap[xeee][yeee],light_off);
					}
					else 
					{
						noteONmap[xeee][yeee]=1;
						sendShortToLaunchpad(144,notemap[xeee][yeee],red_full);
					}
				return;
			}
		}
	
}
